// MyTriangFView.cpp : implementation of the CMyTriangFView class
//

#include "stdafx.h"
#include "MyTriangF.h"

#include "MyTriangFDoc.h"
#include "MyTriangFView.h"
#include "utility.h"
#include "MyCPUTime.h"
#include "Proximity2LNew.h"
#include "SweepTriangle.h"

#include "skiplist.h"
#include "SweepDialog1.h"
#include "US2lDialog1.h"

#include "RandomUtilities.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CMyTriangFView

IMPLEMENT_DYNCREATE(CMyTriangFView, CView)

BEGIN_MESSAGE_MAP(CMyTriangFView, CView)
	//{{AFX_MSG_MAP(CMyTriangFView)
	ON_COMMAND(IDC_LOAD, OnLoad)
	ON_COMMAND(IDC_RANDOM, OnRandom)
	ON_COMMAND(IDC_EXECUTE, OnExecute)
	ON_COMMAND(IDC_CPU_MEASSUREMENT, OnCpuMeassurement)
	ON_COMMAND(IDC_LOADDAT, OnLoaddat)
	ON_COMMAND(IDC_SWEEP, OnSweep)
	ON_COMMAND(IDC_CPU_SWEEP, OnCpuSweep)
	ON_COMMAND(IDC_TEST, OnTest)
	ON_COMMAND(IDC_SWEEP_SAVE, OnSweepSave)
//	ON_UPDATE_COMMAND_UI(ID_CLUSTER, OnUpdateCluster)
	ON_COMMAND(ID_CLUSTERING_DOCLUSTERING, OnClusteringDoclustering)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyTriangFView construction/destruction

CMyTriangFView::CMyTriangFView()
{ XArr = YArr = NULL;
  PlotFlag = 0;
}

CMyTriangFView::~CMyTriangFView()
{
  if (XArr != NULL) delete[] XArr;
  if (YArr != NULL) delete[] YArr;
  XArr = YArr = NULL;
}

BOOL CMyTriangFView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMyTriangFView drawing

void CMyTriangFView::OnDraw(CDC* pDC)
{
	CMyTriangFDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

   if (PlotFlag == 1)
   { HDC hdc = (HDC)pDC->GetSafeHdc( );
     RECT r;
     ::GetClientRect( ::GetParent(GetSafeHwnd( )), &r);

      PlotPoints(hdc);
   }

	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CMyTriangFView diagnostics

#ifdef _DEBUG
void CMyTriangFView::AssertValid() const
{
	CView::AssertValid();
}

void CMyTriangFView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CMyTriangFDoc* CMyTriangFView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMyTriangFDoc)));
	return (CMyTriangFDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMyTriangFView message handlers



CDC* CMyTriangFView::ReturnHDCAndEraseIt()
{ CDC* pDC = GetDC();
   ::GetClientRect( ::GetParent(GetSafeHwnd( )), &r); 
  CBrush* pBrush = new CBrush(pDC->GetBkColor( ) );
  pDC->FillRect(&r, pBrush );
  delete pBrush;
  return pDC;
}  



void CMyTriangFView::PlotPoints(HDC hdc)
{ 
    int xi, yi;

    for (long i = 0; i < NoOfPoints; i++)
    { 
      xi = FromRealToPixel(XArr[i], BoxXMin, BoxXMax - BoxXMin , r.right);
      yi = r.bottom - FromRealToPixel(YArr[i], BoxYMin, BoxYMax - BoxYMin , r.bottom);

      MoveToEx(hdc, xi-3, yi, NULL);
      LineTo(hdc, xi+3, yi);

      MoveToEx(hdc, xi, yi-3, NULL);
      LineTo(hdc, xi, yi+3);

    }
 }





void CMyTriangFView::OnLoad() 
{


  CFileDialog* fd = new CFileDialog( true, "pnt", "input", 
                                     OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
                                     "2D Points (*.pnt)|*.pnt" );

  CString fname;
  char fileName[80];
  bool DoLoadFlag = true;
  if (fd->DoModal() == IDOK)
  { fname = fd->GetFileName( );
    strcpy(fileName, fname.GetBuffer(fname.GetLength( ) )); 
  }
  else
    DoLoadFlag = false;
  delete fd;
  
  BoxXMin = BoxYMin = MAX_DOUBLE;
  BoxXMax = BoxYMax = -MAX_DOUBLE;


  if (DoLoadFlag)
  { 
     ReturnHDCAndEraseIt();
    FILE* fin = fopen(fileName, "rt");
    if (fin != NULL)
    { fflush(fin);
      fscanf(fin, "%d", &NoOfPoints);
      
      long i;     


      if (XArr != NULL)
        delete[] XArr;
      if (YArr != NULL)
        delete[] YArr;

      XArr = new double[NoOfPoints+1];
      YArr = new double[NoOfPoints+1];      

      for (i = 0; i < NoOfPoints; i++)
      {  fscanf(fin, "%lf, %lf", &XArr[i], &YArr[i]);

//XArr[i] = 1000 * XArr[i];
//YArr[i] = 1000 * YArr[i];

/*         PointArray[i].x = x; 
         PointArray[i].y = y; 
         PointArray[i].Index = i;  
         PointArray[i].ListOfTriangles.ListofTriangles = NULL; 
*/
         if (XArr[i] > BoxXMax) BoxXMax = XArr[i];
         if (YArr[i] > BoxYMax) BoxYMax = YArr[i];
         if (XArr[i] < BoxXMin) BoxXMin = XArr[i];
         if (YArr[i] < BoxYMin) BoxYMin = YArr[i];
      }
      fclose(fin);

      double deltax = 0.01 * (BoxXMax - BoxXMin);
      double deltay = 0.01 * (BoxYMax - BoxYMin);

      BoxXMin -= deltax;   BoxYMin -= deltay;
      BoxXMax += deltax;   BoxYMax += deltay;


//      RandomizePoints(NoOfPoints, XArr, YArr);


      PlotFlag = 1;
      Invalidate();
      //CDC* pDC = ReturnHDCAndEraseIt();
//      HDC hdc = pDC->GetSafeHdc();
//      ::GetClientRect( ::GetParent(GetSafeHwnd( )), &r); 

 
     
//      PlotPoints(hdc);
//      ReleaseDC(pDC);
    }
  }	
}



void CMyTriangFView::OnLoaddat() 
{

  CFileDialog* fd = new CFileDialog( true, "dat", "input", 
                                     OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
                                     "2D Points (*.dat)|*.dat" );

  CString fname;
  char fileName[80];
  bool DoLoadFlag = true;
  if (fd->DoModal() == IDOK)
  { fname = fd->GetFileName( );
    strcpy(fileName, fname.GetBuffer(fname.GetLength( ) )); 
  }
  else
    DoLoadFlag = false;
  delete fd;
  
  BoxXMin = BoxYMin = MAX_DOUBLE;
  BoxXMax = BoxYMax = -MAX_DOUBLE;


  if (DoLoadFlag)
  { 
     ReturnHDCAndEraseIt();
    FILE* fin = fopen(fileName, "rt");
    if (fin != NULL)
    { fflush(fin);
      fscanf(fin, "%d", &NoOfPoints);
      
      long i;     


      if (XArr != NULL)
        delete[] XArr;
      if (YArr != NULL)
        delete[] YArr;

      XArr = new double[NoOfPoints+1];
      YArr = new double[NoOfPoints+1];      

      for (i = 0; i < NoOfPoints; i++)
      {  fscanf(fin, "%lf %lf", &XArr[i], &YArr[i]);

//XArr[i] = 1000 * XArr[i];
//YArr[i] = 1000 * YArr[i];

/*         PointArray[i].x = x; 
         PointArray[i].y = y; 
         PointArray[i].Index = i;  
         PointArray[i].ListOfTriangles.ListofTriangles = NULL; 
*/
         if (XArr[i] > BoxXMax) BoxXMax = XArr[i];
         if (YArr[i] > BoxYMax) BoxYMax = YArr[i];
         if (XArr[i] < BoxXMin) BoxXMin = XArr[i];
         if (YArr[i] < BoxYMin) BoxYMin = YArr[i];
      }
      fclose(fin);

      double deltax = 0.01 * (BoxXMax - BoxXMin);
      double deltay = 0.01 * (BoxYMax - BoxYMin);

      BoxXMin -= deltax;   BoxYMin -= deltay;
      BoxXMax += deltax;   BoxYMax += deltay;





      PlotFlag = 1;
      Invalidate();
      //CDC* pDC = ReturnHDCAndEraseIt();
//      HDC hdc = pDC->GetSafeHdc();
//      ::GetClientRect( ::GetParent(GetSafeHwnd( )), &r); 

 
     
//      PlotPoints(hdc);
//      ReleaseDC(pDC);
    }
  }		
}



void CMyTriangFView::OnRandom() 
{

  if (XArr != NULL)
  { delete[] XArr;
    delete[] YArr;
    XArr = YArr = NULL;
  } 
/*
  Dialog1* d = new Dialog1();
  if (d->DoModal() == IDOK)
    NoOfPoints = d->ReturnNo();
  else
    NoOfPoints = 0; 
  delete d;
*/

NoOfPoints = 10000000;

  if (NoOfPoints != 0)
  {
    XArr = new double[NoOfPoints+1];
    YArr = new double[NoOfPoints+1];

    int i;  
    double x, y;
    double a = 1.0/((double)RAND_MAX);
    double half = 0.5 * RAND_MAX;
    srand( (unsigned)time( NULL ) );
    BoxXMin = BoxYMin = -100;// -200000;
    BoxXMax = BoxYMax = 100; //200000;
//BoxXMin = -1000;  BoxXMax = 1000;
//BoxYMin = -1000000;  BoxYMax = 1000000;


    CFileDialog* fd = new CFileDialog( false, "pnt", "input", 
                                       OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
                                       "2D Points (*.pnt)|*.pnt" );

    CString fname;
    char fileName[80];
    bool DoSaveFlag = true;
    if (fd->DoModal() == IDOK)
    { fname = fd->GetFileName( );
     
      strcpy(fileName, fname.GetBuffer(fname.GetLength( ) )); 
    }
    else
      DoSaveFlag = false;
    delete fd;


    if (DoSaveFlag)
    {
     
      FILE* fout = fopen(fileName, "wt");
      fprintf(fout, "%d \n", NoOfPoints);

 
      for (i = 0; i < NoOfPoints; i++)  
      { if (rand() < half)
          x = (int)(BoxXMin * a * rand());
        else
          x = (int)(BoxXMax * a * rand());

        if (rand() < half)
          y = (int)(BoxYMin * a * rand());
        else
          y = (int)(BoxYMax * a * rand());

        fprintf(fout, "%lf, %lf \n", x, y);
        XArr[i]= x;
        YArr[i]= y;
      }
      fclose(fout);  


      CDC* pDC = ReturnHDCAndEraseIt();
      HDC hdc = pDC->GetSafeHdc();

      ::GetClientRect( ::GetParent(GetSafeHwnd( )), &r); 

      PlotPoints(hdc);

      ReleaseDC(pDC);
    }
  }
}

void CMyTriangFView::OnExecute() 
{
 if (NoOfPoints == NULL)
    MessageBox("Points are not loaded");
  else
  {
    RandomizePoints(NoOfPoints, XArr, YArr);
    InitUSPTriang(NoOfPoints, XArr, YArr, BoxXMin, BoxYMin, BoxXMax, BoxYMax);


//  TestClosestPoint();

//  TestTheNextClosestPoint();

  PlotFlag = 0;

  CDC* pDC = ReturnHDCAndEraseIt();
  HDC hdc = pDC->GetSafeHdc();
  ::GetClientRect( ::GetParent(GetSafeHwnd( )), &r); 

  Triangulate();

//   Triangulate(hdc, BoxXMin, BoxYMin, BoxXMax, BoxYMax, r.right, r.bottom);

 
  PlotTriangles(hdc, BoxXMin, BoxYMin, BoxXMax, BoxYMax, r.right, r.bottom);
  PlotTriangulatedPoints(hdc, BoxXMin, BoxYMin, BoxXMax, BoxYMax, r.right, r.bottom, NoOfPoints);

  }

  FinalUSPTriang();	
}

void CMyTriangFView::OnCpuMeassurement() 
{
 if (NoOfPoints == NULL)
    MessageBox("Points are not loaded");
  else
  {

    MyCPUTime* t1 = new MyCPUTime();
    t1->Start();

    RandomizePoints(NoOfPoints, XArr, YArr);

    InitUSPTriang(NoOfPoints, XArr, YArr, BoxXMin, BoxYMin, BoxXMax, BoxYMax);
    t1->Stop();

    PlotFlag = 0;

    MyCPUTime* t2 = new MyCPUTime();
    t2->Start();
    Triangulate();
    t2->Stop();

 

    US2lDialog1* dr = new US2lDialog1();
    double a = t1->GetEllapsedCPUTime();
    double b = t2->GetEllapsedCPUTime();
    dr->SetNoOfVertices(NoOfPoints);
    dr->SetInitTime(a);
    dr->SetTriangulationTime(b);
    dr->SetTotal(a+b);
    dr->SetPinTTests(ReturnPointInTriangleCounter());
    dr->SetNoOfSwaps(ReturnNoOfLegalisations());

    dr->DoModal();

    delete dr;



    FILE* ft = fopen("triangulationF.cpu", "wt");
    fprintf(ft, "no of point %d \n", NoOfPoints);
    fprintf(ft, "Initialisation time %lf \n", t1->GetEllapsedCPUTime());
    fprintf(ft, "Triangulation time  %lf \n", t2->GetEllapsedCPUTime());
    fprintf(ft, "Total time %lf \n", t1->GetEllapsedCPUTime() +
                                   t2->GetEllapsedCPUTime());

    fprintf(ft, "No of point in triangle tests %d \n", ReturnPointInTriangleCounter() );
    fprintf(ft, "No of the next closest point seach %d \n", ReturnTheNextClosestPointCounter());
    fprintf(ft, "No of tested points tested for the closenest %d \n", ReturnNoOfTestedPoints());

    fclose(ft);
    delete t1;
    delete t2;

    FinalUSPTriang();	

    MessageBox("Terminated. See results in triangulationF.CPU");
  }
}

void CMyTriangFView::OnSweep() 
{

  long flag = InitSweepDT(NoOfPoints, XArr, YArr);

  SweepDT(flag);


  CDC* pDC = ReturnHDCAndEraseIt();
  HDC hdc = pDC->GetSafeHdc();
  ::GetClientRect( ::GetParent(GetSafeHwnd( )), &r); 

/*BoxYMax = -20;
BoxXMin = -90;
BoxXMax = -20;
BoxYMin = -90;
*/
  //BoxYMax = BoxYMax - 0.7*(BoxYMax-BoxYMin);
//  BoxYMin = BoxYMax - 0.75*(BoxYMax-BoxYMin);

  PlotTrianglesSweep(hdc, BoxXMin, BoxYMin, BoxXMax, BoxYMax, r.right, r.bottom);
//  PlotTriangulatedPoints(hdc, BoxXMin, BoxYMin, BoxXMax, BoxYMax, r.right, r.bottom, NoOfPoints);

  ReleaseDC(pDC);

  FinalSweepDT();	
}

void CMyTriangFView::OnCpuSweep() 
{
 if (NoOfPoints == NULL)
    MessageBox("Points are not loaded");
  else
  {
    PlotFlag = 0;

    MyCPUTime* t1 = new MyCPUTime();
    MyCPUTime* t2 = new MyCPUTime();

    t1->Start();
    long flag = InitSweepDT(NoOfPoints, XArr, YArr);
    t1->Stop();

    t2->Start();
    SweepDT(flag);
    t2->Stop();


    SweepDialog1* dr = new SweepDialog1();
    double a = t1->GetEllapsedCPUTime();
    double b = t2->GetEllapsedCPUTime();
    dr->SetNoOfVertices(NoOfPoints);
    dr->SetInitTime(a);
    dr->SetSweepTime(b);
    dr->SetTotal(a+b);
    dr->SetNoOfTriangles(ReturnNoOfTriangle());
    dr->SetNoOfSwaps(ReturnSwapCounter());


    dr->DoModal();

    delete dr;


    FILE* ft = fopen("triangSweep.cpu", "wt");
    fprintf(ft, "no of point %d \n", NoOfPoints);
    fprintf(ft, "Initialisation time %lf \n", t1->GetEllapsedCPUTime());
    fprintf(ft, "Triangulation time  %lf \n", t2->GetEllapsedCPUTime());
    fprintf(ft, "Total time %lf \n", t1->GetEllapsedCPUTime() +
                                   t2->GetEllapsedCPUTime());

//    fprintf(ft, "No of point in triangle tests %d \n", ReturnPointInTriangleCounter() );
//    fprintf(ft, "No of the next closest point seach %d \n", ReturnTheNextClosestPointCounter());
//    fprintf(ft, "No of tested points tested for the closenest %d \n", ReturnNoOfTestedPoints());

    fclose(ft);
    delete t1;
    delete t2;

    FinalSweepDT();		

    MessageBox("Terminated. See results in triangSweep.CPU");
  }	
}

void CMyTriangFView::OnTest() 
{
/*
long i;

MyCPUTime t1;
t1.Start();
for (i = 0; i < 1000000; i++)
{
  SkipList* as = new SkipList;
  delete as;
}
t1.Stop();
t1.WriteEllapsedCPUToFile("test.cpu");
*/

long j=0;

    double a = 1.0/((double)RAND_MAX);
    double half = 0.5 * RAND_MAX;
    srand( (unsigned)time( NULL ) );
    double x, y;

BoxXMin = BoxYMin = -100;// -200000;
    BoxXMax = BoxYMax = 100;
 
NoOfPoints = 50;
      XArr = new double[NoOfPoints + 1];
      YArr = new double[NoOfPoints + 1];     

while (1)
{
  FILE* f = fopen("hangUp.txt", "wt");
  fprintf(f, "%ld \n", j++);
  fclose(f);

     FILE* fout = fopen("0.pnt", "wt");
      fprintf(fout, "%d \n", NoOfPoints);

 
      for (long i = 0; i < NoOfPoints; i++)  
      { if (rand() < half)
          x = (int)(BoxXMin * a * rand());
        else
          x = (int)(BoxXMax * a * rand());

        if (rand() < half)
          y = (int)(BoxYMin * a * rand());
        else
          y = (int)(BoxYMax * a * rand());

        fprintf(fout, "%lf, %lf \n", x, y);
        XArr[i]= x;
        YArr[i]= y;
      }
      fclose(fout);  


 
   

  

   
   long flag = InitSweepDT(NoOfPoints, XArr, YArr);
 
    SweepDT(flag);
 
    FinalSweepDT();		
  }

delete[] XArr;
delete[] YArr;




}

void CMyTriangFView::OnSweepSave() 
{

  long flag = InitSweepDT(NoOfPoints, XArr, YArr);

  SweepDT(flag);

/*
  CDC* pDC = ReturnHDCAndEraseIt();
  HDC hdc = pDC->GetSafeHdc();
  ::GetClientRect( ::GetParent(GetSafeHwnd( )), &r); 
*/

/*BoxYMax = -20;
BoxXMin = -90;
BoxXMax = -20;
BoxYMin = -90;
*/
  //BoxYMax = BoxYMax - 0.7*(BoxYMax-BoxYMin);
//  BoxYMin = BoxYMax - 0.75*(BoxYMax-BoxYMin);

//  PlotTrianglesSweep(hdc, BoxXMin, BoxYMin, BoxXMax, BoxYMax, r.right, r.bottom);
//  PlotTriangulatedPoints(hdc, BoxXMin, BoxYMin, BoxXMax, BoxYMax, r.right, r.bottom, NoOfPoints);

  SaveTriangle("Output.trn");


//  ReleaseDC(pDC);

  FinalSweepDT();
	
}

void CMyTriangFView::OnUpdateCluster(CCmdUI* pCmdUI) 
{
  PlotFlag = 0;

  CDC* pDC = ReturnHDCAndEraseIt();
  HDC hdc = pDC->GetSafeHdc();
  ::GetClientRect( ::GetParent(GetSafeHwnd( )), &r); 


  PlotTrianglesSweep(hdc, BoxXMin, BoxYMin, BoxXMax, BoxYMax, r.right, r.bottom);
  PlotTriangulatedPoints(hdc, BoxXMin, BoxYMin, BoxXMax, BoxYMax, r.right, r.bottom, NoOfPoints);

	
}

void CMyTriangFView::OnClusteringDoclustering() 
{
 long flag = InitSweepDT(NoOfPoints, XArr, YArr);

  SweepDT(flag);


  CDC* pDC = ReturnHDCAndEraseIt();
  HDC hdc = pDC->GetSafeHdc();
  ::GetClientRect( ::GetParent(GetSafeHwnd( )), &r); 


//  PlotTrianglesSweep(hdc, BoxXMin, BoxYMin, BoxXMax, BoxYMax, r.right, r.bottom);


  RemoveLongTriangles( hdc, (BoxXMax - BoxXMin) * 0.05, 
                                  BoxXMin, BoxYMin, 
                                  BoxXMax, BoxYMax, 
                                  r.right, r.bottom);

  ReleaseDC(pDC);

  FinalSweepDT();	
	
}
