// Proximity2LNew.h: interface for the Proximity2LNew class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PROXIMITY2LNEW_H__146EFDA0_64F9_11D5_9B4E_004F4902DA76__INCLUDED_)
#define AFX_PROXIMITY2LNEW_H__146EFDA0_64F9_11D5_9B4E_004F4902DA76__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "usptriangF.h"


#define UPPER_ARRAY_LIMIT 150
#define NO_OF_SMALL_CELLS   4
#define THE_SAME_POINTS -100

#define MIDDLE_CELL      100
#define LEFT_CELL        101
#define RIGHT_CELL       102
#define UPPER_CELL       103
#define LOWER_CELL       104
#define LEFT_UPPER_CELL  105
#define LEFT_LOWER_CELL  106
#define RIGHT_UPPER_CELL 107
#define RIGHT_LOWER_CELL 108


typedef struct USPPoint1
{ long index;
  bool Points2LChecked;     // set only at the first point
  struct USPPoint1* next;   // used only in the second level
}USPPointInfo;



typedef struct USPCellInfo1     //information in cells about the points
{ long* Points1L;   
  bool Points1LChecked;
  USPPointInfo* Points2L;
  int NoOfPoints;      
  double Left, Bottom, Right, Top;
  struct USPCellInfo1 ***SecondLevel;
} USPCellInfo;

typedef struct SpiralT     //information in cells about the points
{ int CellX1, CellY1;  
  int code;
} SpiralType;


typedef struct NextClosestP1
{ long index;
  double dist;
  bool UsedFlag;
  struct NextClosestP1* next;
} NextClosestP;


// private
//void FindTheClosestPointInCell(int PoxX, int PosY, long& TheCIndex, double& dis);
void  TheClosestPointInSecondLevel(int PosX, int PosY, int PosX2, int PosY2, double& dis, long& TheCIndex);

// public

int InitProximityStructure(MyPointT* p, double ax1, double ay1, double bx1, double by1, int n);
void ReleaseProximityStructure();
void InsertPoint2USP(long ind);
long DetermineTheClosestPoint(long refPI);
long ReturnTheNextClosestPoint();

long ReturnNoOfTestedPoints();

#endif // !defined(AFX_PROXIMITY2LNEW_H__146EFDA0_64F9_11D5_9B4E_004F4902DA76__INCLUDED_)
