// SkipList.h: interface for the SkipList class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SKIPLIST_H__BFF6A1A1_D6E3_45AA_9D45_7E738ABD01A1__INCLUDED_)
#define AFX_SKIPLIST_H__BFF6A1A1_D6E3_45AA_9D45_7E738ABD01A1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

typedef struct TerminalNode1
{
  TerminalNode1* left;
  TerminalNode1* right;
  long TriangleIndex;
  double x,y;
  int DeleteFlag;
} TerminalNode;


typedef struct SkipList1
{ SkipList1* forward;
  SkipList1* down;
  TerminalNode1* terminalPointer;
  double key;
  int Counter;
  int DeleteFlag;
} SkipList;

SkipList* InitSkipList(int sv);
void FreeSkipList(SkipList*);
int InsertIntoSL(SkipList** slp, double x, double y, long ti);
int DeleteFromSL(SkipList* skl, TerminalNode* t1, TerminalNode* t2);
int FindInterval(SkipList* skl, double Interval, 
            TerminalNode** TLeft,
            TerminalNode** TRight);
void PrintOutSkipList(char* FName);
void PrintOutSkipList(SkipList* skl, char* FName);
SkipList* GenerateTop();
#endif // !defined(AFX_SKIPLIST_H__BFF6A1A1_D6E3_45AA_9D45_7E738ABD01A1__INCLUDED_)
