// SweepTriangle.h: interface for the SweepTriangle class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SWEEPTRIANGLE_H__5FF62CA8_AB77_4155_BF31_09A973888B53__INCLUDED_)
#define AFX_SWEEPTRIANGLE_H__5FF62CA8_AB77_4155_BF31_09A973888B53__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "USPTriangF.h"
#include "SimpleSkipList.h"


typedef struct VertexStruct1// point to be triangulated
{ long Index;
  double x, y;

} VertexStruct;


// locals
void QSort(long iLo, long iHi);
int InitAF();  
void InitAFBottom(long n );
void FinalSweepDT();

void FirstTriangle();
int BottomTriangles();
int  SolveMiddleCase(long i, DoubleLinkedList*, 
                             DoubleLinkedList*);
int SolveOnEDGE(long i, DoubleLinkedList* Left, 
                        DoubleLinkedList* RightAF);
int SolveLeftCase(long i);
int SolveRightCase(long i);
void InsertNewTriangle(long NewVertexIndex, DoubleLinkedList* lt, DoubleLinkedList* rt);
//int  InsertInAF(double x, double y, long VertexIndex, long TriangleIndex);
//void DeleteAFElement(SkipListType* Element);
void CheckDT(long T1, long T2);
void CloseNewTriangleLeft(long NewVertexIndex, 
                          DoubleLinkedList* LeftP, 
                          DoubleLinkedList* NextLeftP);
void CloseNewTriangleRight(long NewVertexIndex, 
                           DoubleLinkedList* RightP, 
                           DoubleLinkedList* NextRightP);

void CloseNewTriangleLeftDown(long NewVertexIndex, 
                              long TIndex,
                              DoubleLinkedList* LeftP, 
                              DoubleLinkedList* NextLeftP);

void CloseNewTriangleRightDown(long NewVertexIndex, 
                              long TIndex,
                              DoubleLinkedList* RightP, 
                              DoubleLinkedList* NextRightP);

void   MakeTrianglesToTheRight(int MiddleF, double x, double y, long i, 
                               DoubleLinkedList* RightTower);
void   MakeTrianglesToTheLeft(int MiddleF, double x, double y, long i, 
                               DoubleLinkedList* LeftTower);

void CloseNewTriangleLeftMiddle(long NewVertexIndex, 
                          DoubleLinkedList* LeftP, 
                          DoubleLinkedList* NextLeftP);
void CloseNewTriangleRightMiddle(long NewVertexIndex, 
                           DoubleLinkedList* RightP, 
                           DoubleLinkedList* NextRightP);

int PrepareTriangles(long t1, long t2);
void SHRVertices(BaseTriangle* t);
void CheckBorderFlag(int TIndex);

// globals
int InitSweepDT(long n, double* xarr, double* yarr);
void SweepDT(long startVertex);	
//int FindRange(double x);
void UpdateTriangleIndex(int ti);

void  PlotTrianglesSweep(HDC hdc, double BoxXMin, double BoxYMin, 
                                  double BoxXMax, double BoxYMax, 
                                  int right, int bottom);

void PrintTriangulation();
void SetNeighbour(long T1, long v1, long v2, long TIndex);
void ReplaceNeighbour1(long TIndex, long OldT, long NewNeighbour);
long SetTIndex(long T,  long v1, long v2);
void UpdateTIndexLow(long v1, long v2, long TIndexNew);

double PositiveSignedArea(double x, double y, double x1, double y1,
                        double x2, double x3);

double NegativeSignedArea(double x, double y, double x1, double y1,
                        double x2, double x3);

#endif // !defined(AFX_SWEEPTRIANGLE_H__5FF62CA8_AB77_4155_BF31_09A973888B53__INCLUDED_)
