
#if !defined(_UTILITY__INCLUDED_)
#define _UTILITY__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000


#include "globals.h"



int Equal(double a, double b);
int Equal(double a, double b, double delta);
int FromRealToPixelX(double x, double xwmin, double dx, int pixelsize);
int FromRealToPixelY(double x, double xwmin, double dx, int pixelsize);
int FromRealToPixel(double x, double xwmin, double dx, int pixelsize);
int Signum(double a);
int Sign(double a);
int Sign(int a);
int Potenca(int osnova, int potenca);
int Odd(int k);
int Normalize(Point& v);
double Sqr(double);

void GetVector(Point3 &a, Point3 &b, Point3& c);
void VectorProduct(Point3& a, Point3& b, Point3& out);
double VectorProduct(Point& a, Point& b);
int TheSameSign(Point3& p1, Point3& p2, Point3& q1, Point3& q2);
double ScalarProduct(Point3 &a, Point3 &b);
double ScalarProduct(double x1, double y1, double x2, double y2,
                     double x3, double y3);
double LenghtOfVector(Point3 &a);

int Collinear2D(double x1, double y1, double x2, double y2, double x3, double y3);
double ReturnTangAgainstX(double x, double y, int &quadrant);
double AngleAgainstX(double x, double y);
double DistanceBetween2DPoints(double x1, double y1, double x2, double y2);
int TheSamePoints2D(double x1, double y1, double x2, double y2);
int TheSamePoints2D(double x1, double y1, double x2, double y2, double delta);
int TheSamePoints2D(Point* p1, Point* p2);
int TheSamePoints2D(Point* p1, Point* p2, double delta);
int Between0_1(double a);

double Maximum(double a, double b);
double Minimum(double a, double b);
void Swap(int& a, int& b);
void Swap(double& a, double& b);
void Swap(Point& a, Point& b);
int IsDecimalNumber(double u);

int BigEndianLongInt(int a);

int SquareEquation(double a, double b, double c, double& xout1, double& xout2);
double SignedArea(double x1, double y1, double x2, double y2, double x3, double y3);
int TriangleOutscribedCircle(double x1, double y1, double x2, double y2, 
                             double x3, double y3, double& x, double& y, double& r);

#endif 

